#version 330

layout (triangles) in;							// Format of the input primitive
layout (triangle_strip, max_vertices = 3) out;	// Format of the output primitive

uniform float time = 0.5f;

out vec4 color;

//----------------------------------------------------------------
// TODO:
// 1) Compute face normal as cross product of triangle edge vectors.
// 2) Move the triangle vertices along the normal.
// 3) What is the difference against doing this in the vertex shader?
//----------------------------------------------------------------

void main()
{
	// Calculate two vectors in the plane of the input triangle
	vec3 ab = gl_in[1].gl_Position.xyz - gl_in[0].gl_Position.xyz;
	vec3 ac = gl_in[2].gl_Position.xyz - gl_in[0].gl_Position.xyz;

	// Calculate the face normal
	vec3 normal = normalize(cross(ac, ab));

	// Move vertex positions along face normal
	for(int i = 0; i < gl_in.length(); i++)
	{
		gl_Position = gl_in[i].gl_Position + vec4(2.f*sin(0.5*time) * normal, 0.f);
		color = vec4(0.f, 0.f, 0.f, 1.f);
		color[i] = 1.f;
		EmitVertex();
	}

	EndPrimitive();
}